/*
 * Copyright (c) 2007 NTT DATA Corporation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package jp.terasoluna.batch.tutorial.uc0001.jb0001;

import java.util.Date;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import jp.terasoluna.batch.tutorial.uc0001.JB0001Data;
import jp.terasoluna.batch.tutorial.uc0001.JB0001JobContext;
import jp.terasoluna.fw.batch.messages.MessageAccessor;
import jp.terasoluna.fw.batch.openapi.BLogic;
import jp.terasoluna.fw.batch.openapi.BLogicResult;
import jp.terasoluna.fw.batch.openapi.ReturnCode;
import jp.terasoluna.fw.dao.QueryDAO;
import jp.terasoluna.fw.dao.UpdateDAO;

/**
 * ビジネスロジッククラス。
 */
public class DBBLogic implements BLogic<JB0001Data, JB0001JobContext> {

    /**
     * ログクラス。
     */
    private static final Log log = LogFactory.getLog(DBBLogic.class);
    
    /**
     * DAOクラス。
     * Springによりインスタンス生成され設定される。
     */
    private QueryDAO queryDAO = null;
    
    /**
     * DAOクラス。
     * Springによりインスタンス生成され設定される。
     */
    private UpdateDAO updateDAO = null;
   
    /**
     * メッセージ取得クラス。
     * Springによりインスタンス生成され設定される。
     */
    private MessageAccessor messageAccessor = null;
    
    /**
     * ビジネスロジックを実行する。
     * @param nyukinData 入力パラメータ
     * @param jobContext ジョブコンテキスト
     * @return ビジネスロジック処理結果
     */
    public BLogicResult execute(JB0001Data nyukinData,
            JB0001JobContext jobContext) {

        //取引日と運用日付の比較
        Date torihikibi = nyukinData.getTorihikibi();
        Date unyohiduke = jobContext.getUnyohiduke();
    
    
        if (!torihikibi.before(unyohiduke)) {
            
            //取引日 >= 運用日付 ならばメッセージを取得しログに出力する。
            String[] args = {nyukinData.getKokyakuid()};
            String message = messageAccessor.getMessage("msg.SampleMsg", args);
            
            log.warn(message);
            
            /* 「2.2.5 例外処理の実装」では以下のコメント行を有効にする。 */
            /*
            //ビジネスロジック結果オブジェクトを返却する。
            return new BLogicResult(ReturnCode.ERROR_END);

            //任意のジョブ終了コードを設定する場合は、以下のように第2引数にジョブ終了コードを指定する。
            //return new BLogicResult(ReturnCode.ERROR_END, 99);
            */

        }
        
        //残高テーブル参照
        ZandakaData zandakaData =
            queryDAO.executeForObject("UC0001.getZandakaData",
                    nyukinData.getKokyakuid() , ZandakaData.class);
    
        //該当レコードがある場合は残高計算と更新
        if (zandakaData != null) {
            int zandaka = zandakaData.getZandaka() + nyukinData.getNyukin();
            zandakaData.setZandaka(zandaka);
            zandakaData.setSaisyutorihikibi(nyukinData.getTorihikibi());
            zandakaData.setKokyakuid(nyukinData.getKokyakuid());
            updateDAO.execute("UC0001.updateZandakaData", zandakaData);
    
        //該当レコードが無い場合は新規作成
        } else {
            zandakaData = new ZandakaData();
            zandakaData.setKokyakuid(nyukinData.getKokyakuid());
            zandakaData.setZandaka(nyukinData.getNyukin());
            zandakaData.setSaisyutorihikibi(nyukinData.getTorihikibi());
            updateDAO.execute("UC0001.insertZandakaData", zandakaData);
        }
        
        //処理件数をカウントアップ
        jobContext.incrementCount();
        
        //ビジネスロジック処理結果オブジェクトを返却する
        return new BLogicResult(ReturnCode.NORMAL_CONTINUE);
    }

    /**
     * QueryDAOを設定する。
     * @param queryDAO 設定するQueryDAO
     */
    public void setQueryDAO(QueryDAO queryDAO) {
        this.queryDAO = queryDAO;
    }

    /**
     * UpdateDAOを設定する。
     * @param updateDAO 設定するUpdateDAO
     */
    public void setUpdateDAO(UpdateDAO updateDAO) {
        this.updateDAO = updateDAO;
    }

    /**
     * メッセージ取得クラスを設定する。
     * @param msgAcc メッセージ取得クラス
     */
    public void setMessageAccessor(MessageAccessor msgAcc) {
        this.messageAccessor = msgAcc;
    }

}
